// WAVEFLT FRONT END  easy Wave Cutter C
// Copyright (c) 1999-2002 Tomoya Tokairin
//
// E-mail : tokai@main.eng.hokudai.ac.jp
//
// {vÔׂāA܂͈ꕔ GPL ɏ]čĔЕz܂͕ύX
// Ƃł܂BڍׂɂĂGNU ʌLgpǂ݂B


#include "common.h"


int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPreInst,
                   LPSTR lpszCmdLine, int nCmdShow)
{
	HWND hWnd;
    MSG msg;
    WNDCLASS wndClass;
	HACCEL hAccel = NULL;
	
	DWORD i;
	
	// ҏWf[^pϐ
	EWCDATA ewcData;
	
	// R}hCp
	CHAR argv[MAX_ARGC][CHR_BUF];
	int argc;

	// EBhEo^
    if (!hPreInst) {
        wndClass.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
        wndClass.lpfnWndProc = EditWaveProc;
        wndClass.cbClsExtra = 0;
        wndClass.cbWndExtra = 0;
        wndClass.hInstance = hInst;
		wndClass.hIcon  = LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON));
        wndClass.hCursor = LoadCursor(NULL,IDC_ARROW);
        wndClass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
        wndClass.lpszMenuName = NULL;
        wndClass.lpszClassName = "E-WC";
        if (!RegisterClass(&wndClass)) return 0;
    }	


	// EWCDATA \̏ݒ
	ZeroMemory(&ewcData,sizeof(EWCDATA));
	
	// TEhfoCX̏擾
	ewcData.uDevNum = GetWaveOutDevCap(ewcData.waveOutCaps,MAXDEVICENUMBER);
	

	// ݒt@Cǂݍ

	// ݒt@CZbg
	CHAR szStr[MAX_PATH];
	CHAR szDriveName[MAX_PATH],szPathName[MAX_PATH];
	GetModuleFileName(NULL,szStr,MAX_PATH); 
	_splitpath(szStr,szDriveName,szPathName,NULL,NULL);	
	wsprintf(ewcData.szIniDatFile,"%s%sewc.dat",szDriveName,szPathName);
	ReadIniFile(&ewcData,ewcData.szIniDatFile);
	
	// R}hC擾
	argc = GetArgv(lpszCmdLine,argv,1);
	
	// t@CZbg
	if(argc > 1) if(ShortToLongName(argv[1])) wsprintf(ewcData.szIniFileName,argv[1]);
	
	// foCXZbg
	if(strcmp(argv[2],"-dev") == 0){
		ewcData.uDeviceID = atoi(argv[3]);
	}
	
	// gbNݒ
	ewcData.szTrackFile[0] = '\0';
	strcpy(ewcData.szBaseName,"track");
	strcpy(ewcData.szExtName,"wav");
	ewcData.szTrackName[0] = (CHAR*)malloc(sizeof(CHAR)*MAX_SPLITNUM*CHR_BUF+1024);
	for(i=1;i<MAX_SPLITNUM;i++) ewcData.szTrackName[i] = ewcData.szTrackName[0] + i*CHR_BUF;
	for(i=0;i<MAX_SPLITNUM;i++) wsprintf(ewcData.szTrackName[i],"%s-%03d.%s",ewcData.szBaseName,i+1,ewcData.szExtName);

	// EBhE쐬
    hWnd = CreateWindow(
		"E-WC",
        "ewc",
        WS_VISIBLE|WS_CAPTION|WS_POPUPWINDOW|WS_SYSMENU|WS_MINIMIZEBOX,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        NULL,NULL,hInst,(LPVOID)&ewcData);
	
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);	

	// ANZ[^[e[ũ[h
	hAccel = LoadAccelerators(hInst,MAKEINTRESOURCE(IDR_ACCELERATOR));

	if(hAccel == NULL) 
		MyMessageBox(NULL,"ANZ[^[e[ũnh\n擾Ɏs܂B"
		,"error",MB_OK|MB_ICONERROR);
	else 
		while (GetMessage(&msg, NULL, 0, 0)) {	// bZ[W[v
			if(!TranslateAccelerator(hWnd,hAccel,&msg))  // ANZ[^[
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}


	// ݒt@Cۑ
	SaveIniFile(&ewcData,ewcData.szIniDatFile);

	// J
	free(ewcData.szTrackName[0]);

	
	return 0;
}


//EOF