// easy Wave Cutter
// Copyright (c) 1999-2002 Tomoya Tokairin
// T[`p֐

#include "common.h"
#include <math.h>

// T[`_CAOƃXbhɓnf[^^
typedef struct
{
HWND hWnd;
HWND hProgBar;  // vOXo[̃nh
HANDLE hdFile; // T[`t@Cnh
LONGLONG n64DataSize; //t@CTCY
LONGLONG n64DataOffset; //f[^܂ł̃ItZbg
WAVEFORMATEX waveFmt; // Wave tH[}bg
LONGLONG* lpn64StartByte; // Jnʒu(oCg)
LONGLONG* lpn64EndByte;  // Iʒu(oCg)
LPWORD lpwStatus; // Xe[^X
double dBound; // l
DWORD dwMaxCount;  // ̃JE^̍ől(1/25 bP)
BOOL bAvr; // ωʂŌ
}SEARCHDATA,*LPSEARCHDATA;


//-------------------------------------------------------------------
// T[`Xbh
DWORD WINAPI SearchThread(LPVOID lpSearchData) 
{
	
	LPSEARCHDATA lpSdata = (LPSEARCHDATA)lpSearchData;
	HWND hWnd  	// e_CAÕEBhEnh
		= lpSdata->hWnd; 
	HWND hProgBar 	// isvOXo[̃nh  
		= lpSdata->hProgBar; 
	HANDLE hdFile 	// t@Cnh
		= lpSdata->hdFile	; 
	LONGLONG n64DataSize 	//f[^TCY
		= lpSdata->n64DataSize; 
	WAVEFORMATEX waveFmt // Wave tH[}bg
		= lpSdata->waveFmt;
	LONGLONG n64DataOffset 	//f[^܂ł̃ItZbg
		= lpSdata->n64DataOffset; 
	LONGLONG* lpn64StartByte 	// Jnʒu(oCg)
		= lpSdata->lpn64StartByte; 
	LONGLONG* lpn64EndByte 	// Iʒu(oCg)
		= lpSdata->lpn64EndByte; 
	LPWORD lpwStatus 	// Xe[^X
		= lpSdata->lpwStatus; 
	double dBound // dB, l
		= lpSdata->dBound; 
	DWORD dwMaxCount // JE^̍ől
		= lpSdata->dwMaxCount; 
	
	// t@Cǂݍݕۑpϐ
	DWORD dwByte;
	DWORD dwReadByte; // ǂݍރoCg
	LONGLONG n64CurByte = *lpn64StartByte; //݈ʒu
	LONGLONG n64StartByte = n64CurByte; // ̊Jnʒu(byte)
	LONGLONG n64EndByte; // ̏Iʒu(byte)
	DWORD dwMovePoint; // t@C|C^̈ړ
	DWORD dwCount;  // ̃JE^
	LPBYTE lpBuffer = NULL; // Rs[p̃obt@
	double dWaveLevel[2]; // ̓xvZ
	double dMaxLevel;
	LARGE_INTEGER LI; // SetFilePointer p 

	BOOL bSucceed = FALSE; //  TRUE
	
	DWORD i;
	DWORD dwProgPos; // vOXo[̃|WV
	
	// nh NULL łȂ`FbN
	if(hdFile == NULL){ 
		
		MyMessageBox(hWnd, "t@CI[vĂ܂B", 
			"Error", MB_OK|MB_ICONERROR);	
		
		// sbZ[WM
		SendMessage(hWnd,WM_MYENDCOPY,0,1L);
		ExitThread(1L);
	}

	// Jnʒuf[^TCY𒴂Ă鎞
	if(n64CurByte > n64DataSize)
	{
		n64CurByte = n64DataSize;
		n64StartByte = n64CurByte;
		n64EndByte = n64StartByte;
		goto L_EXIT;
	}
	
	// isvOXo[ݒ	 
	dwProgPos = ((DWORD)(n64CurByte/SAVEBUFSIZE));
	SendMessage(hProgBar,PBM_SETRANGE,0,MAKELPARAM(0,(DWORD)(n64DataSize/SAVEBUFSIZE))); 
	SendMessage(hProgBar,PBM_SETSTEP,(WPARAM)1,0);
	SendMessage(hProgBar,PBM_SETPOS,(WPARAM)dwProgPos,0);   

	// x (-1 - 1 ɐK)
	dMaxLevel = GetMaxWaveLevel(waveFmt);
	dBound = pow(10.,dBound/20);  // jAlɖ߂
	
	// |C^̈ړ
	// bԂ waveFmt.nSamplesPerSec gĖ̔Ă̂
	// waveFmt.nSamplesPerSec/S_POINT_PER_SEC _Ƃɔ肷
	dwMovePoint = waveFmt.nSamplesPerSec/S_POINT_PER_SEC;
	
	// obt@m
	lpBuffer =(LPBYTE)GlobalAlloc(GPTR,sizeof(BYTE)*SAVEBUFSIZE);
	if(lpBuffer == NULL)
	{
		MyMessageBox(hWnd, "̊mۂɎs܂B",
			"Error", MB_OK|MB_ICONERROR);
		
		// sbZ[WM
		SendMessage(hWnd,WM_MYENDCOPY,0,1L);
		return 1;
	}
	
	
	//---------------------------------------
	// T[`Jn
	
	dwCount = 0;
	while(n64CurByte < n64DataSize && *lpwStatus==ID_SEARCHON)
	{
		// vOXp[Abv
		SendMessage(hProgBar,PBM_SETPOS,(WPARAM)dwProgPos,0);
		dwProgPos++;
		
		// f[^ǂݍ݃TCYvZ
		dwReadByte = n64CurByte + SAVEBUFSIZE > n64DataSize
			? (DWORD)(n64DataSize - n64CurByte) : SAVEBUFSIZE;
		
		// ǂ
		LI.QuadPart = n64DataOffset+n64CurByte; // T[`JnʒuɃ|C^ړ
		SetFilePointer(hdFile,LI.LowPart, &LI.HighPart,FILE_BEGIN);
		memset(lpBuffer,0,sizeof(BYTE)*SAVEBUFSIZE);
		ReadFile(hdFile,lpBuffer,dwReadByte,&dwByte, NULL);
		
		// obt@T[`
		for(i = 0;i < dwByte/waveFmt.nBlockAlign ;i+=dwMovePoint)
		{
			if(lpSdata->bAvr)
				//dwMovePoint_̕ωʎ擾
				WaveLevelAverage(dWaveLevel,lpBuffer+i*waveFmt.nBlockAlign,waveFmt,dwMovePoint*waveFmt.nBlockAlign);
			else
				// o͒l擾
				WaveLevel(dWaveLevel,lpBuffer+i*waveFmt.nBlockAlign,waveFmt);

			//K
			dWaveLevel[0] /= dMaxLevel;
			dWaveLevel[1] /= dMaxLevel;
			
			// 
			if(fabs(dWaveLevel[0]) <= dBound && fabs(dWaveLevel[1]) <= dBound) dwCount++;
			else { // Lꂽ
				
				if(dwCount >= dwMaxCount) {	// 
					n64EndByte = n64StartByte+waveFmt.nBlockAlign*dwMovePoint*dwCount;
					bSucceed = TRUE;
					goto L_EXIT;
				}
				
				n64StartByte = n64CurByte+i*waveFmt.nBlockAlign;
				dwCount = 0;
			}
		}
		
		n64CurByte += dwByte;
	}

L_EXIT:	
	
	// J
	if(lpBuffer) GlobalFree(lpBuffer);
	
	// ʒuZbg
	*lpn64StartByte = n64StartByte;
	*lpn64EndByte = n64EndByte;

	// ʑM
	SendMessage(hWnd,WM_MYENDCOPY,0,bSucceed);
	
	return(0);
}



//-------------------------------------
// T[`_CAÕvV[W
// Xbh𓮂Ă邾B
LRESULT CALLBACK SearchDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	
	static HANDLE hThread;  // Xbh̃nh
	static DWORD threadId; // Xbh ID
	static LPSEARCHDATA lpSearchData; // Xbhɓnf[^^Cv
	static WORD wStatus; // Xe[^X
	
	switch (msg) {
		
	case WM_INITDIALOG:  // _CAO
		
		// _CAO𒆐SɈړ
		SetDlgCenter(hWnd);
		
		// ۑXbhN
		wStatus = ID_SEARCHON;
		lpSearchData = (LPSEARCHDATA)lp;
		lpSearchData->hWnd = hWnd;
		lpSearchData->hProgBar = GetDlgItem(hWnd,IDC_PROGBAR);
		lpSearchData->lpwStatus = &wStatus;
		
		hThread = CreateThread(NULL,0,
			(LPTHREAD_START_ROUTINE)SearchThread,
			(LPVOID)lpSearchData,
			0,(LPDWORD)&threadId);
		
		if(hThread == NULL){	   
			MyMessageBox(hWnd, "Xbh̋NɎs܂B", 
				"Error", MB_OK|MB_ICONERROR);
			EndDialog(hWnd, IDCANCEL); 
		}
		
		break;
		
	case WM_MYENDCOPY: // T[`
		
		if((DWORD)lp == FALSE) EndDialog(hWnd, IDCANCEL); // s
		else EndDialog(hWnd, IDOK);  // 
		
		break;
		
	case WM_COMMAND:
		
		switch (LOWORD(wp)) {
			
		case IDCANCEL: // ~
			
			wStatus = ID_SEARCHOFF;
			return TRUE;
			
		}
		
		break;
		
		default: return FALSE;
	}
	
	return TRUE;
}




//-------------------------------------------
// T[`Jn֐
// ۂ̓_CAOJB
BOOL SearchNoSound(HWND hWnd,
				   HINSTANCE hInst,
				   HANDLE hdFile, // T[`t@Cnh
				   LONGLONG n64DataSize, //t@CTCY
				   LONGLONG n64DataOffset, //f[^܂ł̃ItZbg
				   WAVEFORMATEX waveFmt, // Wave tH[}bg
				   LONGLONG* lpn64StartByte, // Jnʒu(oCg)
				   LONGLONG* lpn64EndByte, // Iʒu(oCg)
				   double dBound, // l
				   DWORD dwCount,  // ̃JE^̍ől
				   BOOL bAvr	// ωʒlgp
				   ){
	
	SEARCHDATA searchData;
	
	// _CAOɓnf[^Zbg
	searchData.hdFile = hdFile;
	searchData.n64DataSize = n64DataSize;
	searchData.waveFmt = waveFmt;
	searchData.n64DataOffset = n64DataOffset;
	searchData.lpn64StartByte = lpn64StartByte;
	searchData.lpn64EndByte = lpn64EndByte;
	searchData.bAvr = bAvr;
	
	searchData.dBound = dBound;
	searchData.dwMaxCount = dwCount;
	
	// _CAO{bNX\ƕۑJn
	if(DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_SEARCH)
		,hWnd,(DLGPROC)SearchDlgProc,
		(LPARAM)&searchData) == IDCANCEL) return FALSE;
	
	return TRUE;
}


//EOF
